Removed some more trailing whitespace.
[wine] / tools / wineinstall
1 #!/bin/bash
2 # WINE Installation script
3 # Can do almost everything from compiling to configuring...
4 #
5 # Copyright 1999 Ove Kåven
6 #
7 # This library is free software; you can redistribute it and/or
8 # modify it under the terms of the GNU Lesser General Public
9 # License as published by the Free Software Foundation; either
10 # version 2.1 of the License, or (at your option) any later version.
11 #
12 # This library is distributed in the hope that it will be useful,
13 # but WITHOUT ANY WARRANTY; without even the implied warranty of
14 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
15 # Lesser General Public License for more details.
16 #
17 # You should have received a copy of the GNU Lesser General Public
18 # License along with this library; if not, write to the Free Software
19 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
20 #
21 # History:
22 # Mar 31 1999 - Ove Kåven
23 #  First version
24 # Dec 9 1999 - Ove Kåven
25 #  require Xpm
26 # Feb 25 2000 - Ove Kåven
27 #  auto-add /usr/local/lib to /etc/ld.so.conf
28 # Mar 2 2000 - Ove Kåven
29 #  source rather than grep config.cache
30 #  use sourced config.cache to start ldconfig
31 #  reconfigure if config.cache doesn't exist
32 # Mar 30 2000 - Ove Kåven
33 #  autoconfigure no-windows installs
34 #  do not install registry on real-windows installs
35 #  some support for binary package installs
36 #  set and tell user about LD_LIBRARY_PATH if necessary
37 #  set EXTRA_LD_LIBRARY_PATH in wine.conf
38 # Apr 9 2000 - Ove Kåven
39 #  make root's registry global (system-default)
40 # May 9 2000 - Ove Kåven
41 #  use ttydrv when running regapi, so we don't have to run from X
42 #  change debugger path in registry
43 # Oct 29 2000 - Ove Kåven
44 #  added --enable-opengl to default confargs
45 #  added conf_question, conf_yesno_answer, and conf_string_answer functions
46 #  added DEFCAT variable
47 # (later that day...)
48 #  added conf_reset_question function
49 #  added file existence checks to the registry copying
50 #  fixed problem with no-windows directory creation
51 #  some text reformatting from Eric Maryniak
52 # Jan 5 2000 - Chris Morgan
53 #  use default config file in /documentation/samples/config
54 #  replace .winerc with ~/.wine/config in printed text
55 #  added user question to convert .winerc file(if exists) or use the default
56 #    config file
57 #  add conf_question to allow root to install a local config file and
58 #    registry
59 # Jan 12 2000 - Chris Morgan
60 #  distinguish between creating local and global config files
61 #  display a message about the status of global config files
62 #  misc cleanups and reordering of questions
63 #  added check to see if wine is installed when we are running as a normal
64 #    user and print a message if wine cannot be found
65 # Feb 16 2002 - Adam D. Moss
66 #  Use config.status instead of config.cache to check whether we're
67 #    configured/compiled and to recreate the configuration
68 # Feb 20 2002 - Adam D. Moss
69 #  Partially revert previous changes, force configure to write an
70 #    old-style config.cache
71 # Mar 27 2002 - Chris Morgan
72 #  prevent the user from running wineinstall as root
73 #  add script commands so we su root for 'make install' and other commands
74 #    that require root access
75 #  add text to tell the user we need to run stuff as root so they don't
76 #    think we are trying to pull something funny
77 # Apr 14 2002 - Dustin Navea
78 #  Fix sed command when finding real-windows registry so it actually
79 #   accesses a file (~/.wine/config) instead of null ($CONF?!)
80 #  Added search for clean-install (not upgrade) Win2k registry
81 #  (next day, after some sleep)
82 #  Fix sed string when finding real-windows registry to actually find
83 #   windows partition name in [Drive C] section
84 #  it should now almost always find the windows partition and real-windows
85 #  registry (if not, let me know)
86
87 #--- defaults (change these if you are a packager)
88 CONFARGS="--enable-opengl"    # configure args, e.g. --prefix=/usr --sysconfdir=/etc
89 prefix=/usr/local             # installation prefix
90 sysconfdir=$prefix/etc        # where wine.conf and global registry is supposed to be
91 bindir=$prefix/bin            # where winelib apps will be (or is) installed
92 libdir=$prefix/lib            # where libwine.so will be (or is) installed
93 exdir=documentation/samples   # where the example system.ini resides
94 GCONF=$sysconfdir/wine.conf   # default path of the wine.conf global config file
95 LCONF=~/.wine/config          # default path of the local config file
96 BINDIST=no                    # whether called from a binary package config script
97 DOGLOBALCONF=auto             # whether to autogenerate wine.conf
98 DOLOCALCONF=auto              # whether to autogenerate localconf
99 DOWCHK=auto                   # whether to autoconfigure existing-windows installation
100 DOWINE=auto                   # whether to autoconfigure no-windows installation
101 DOREG=auto                    # whether to install default registry
102 DOAPP=auto                    # whether to install applications, distributed with Wine
103 SYSREG=yes                    # whether to make root's registry global (system-default)
104 CONVCONF=no                   # whether we are converting an existing .winerc or not
105
106 # "make install" still installs the dlls into $libdir, but this may change in the future
107 # (DLLPATH should point to them if/when they are not in standard ld.so paths)
108 DLLPATH=$libdir/wine          # default path of the dll .so files (except libwine.so)
109
110 # having the Wine debugger launched automatically will be a plus for us
111 DEBUGGER=$bindir/winedbg      # the (installed) path of winedbg
112 HDEBUGGER=debugger/winedbg    # the (non-installed) path of winedbg
113
114 # this is only for existing-windows installs
115 WINECONF=tools/wineconf       # the path of wineconf perl script
116
117 # this is only for no-windows installs
118 WINEINI=$exdir/config         # the path of default wine config file (also used by wineconf)
119 WININI=/dev/null              # the path of default win.ini
120 SYSTEMINI=$exdir/system.ini   # the path of default system.ini
121 REGEDIT=programs/regedit/regedit # the path of regedit winelib application
122 DEFREG=winedefault.reg        # the path of the registry file to be fed to regedit
123 # CROOT=/var/wine             # the path of the fake Drive C (asks user if not set)
124 DEFCAT=cat                    # program to cat $DEFREG with (some packages need zcat)
125 #--- end of defaults
126
127 # temporary files used by the installer
128 TMPCONF=/tmp/wineinstall.conf
129 TMPREG=/tmp/wineinstall.reg
130
131 # functions
132
133 function std_sleep {
134   sleep 1
135 }
136
137 function conf_question {
138   # parameters: $1 = importance, $2 = question-id, $3+ = message lines
139   # the first two parameters can be used by e.g. debconf in debian packages
140   # but here we just print the message
141   shift 2
142   echo
143   local LINE="$1"
144   while shift
145   do {
146     echo "$LINE"
147     LINE="$1"
148   }
149   done
150 }
151
152 function conf_reset_question {
153   # parameters: $1 = question-id
154   # this is used to flush any cached answers and "already-displayed" flags
155   shift # dummy command
156 }
157
158 function conf_yesno_answer {
159   unset ANSWER
160   while [ "$ANSWER" != 'yes' ] && [ "$ANSWER" != 'no' ]
161   do {
162     echo -n "$1"
163     read ANSWER
164   }
165   done
166 }
167
168 function conf_string_answer {
169   echo -n "$1"
170   read ANSWER
171 }
172
173 function create_windows_directories {
174   for tdir in "$CROOT/windows" "$CROOT/windows/system" "$CROOT/windows/system32" \
175               "$CROOT/windows/Start Menu" "$CROOT/windows/Start Menu/Programs" \
176               "$CROOT/Program Files" "$CROOT/Program Files/Common Files" \
177               "$CROOT/windows/Profiles" "$CROOT/windows/Profiles/Administrator" \
178               "$CROOT/windows/Fonts" "$CROOT/windows/Start Menu/Programs/Startup"
179   do [ -d "$tdir" ] || mkdir "$tdir"
180   done
181   [ -f "$CROOT/windows/win.ini" ]    || cp "$WININI"    "$CROOT/windows/win.ini"
182   [ -f "$CROOT/windows/system.ini" ] || cp "$SYSTEMINI" "$CROOT/windows/system.ini"
183 }
184
185 #creates symbolic link in windows directory to installed winelib application
186 #parameters:
187 # - name of the installed winelib application
188 # - full path to application in the winelib directory
189 function link_app {
190   ln -sf $bindir/$1 $2
191   ln -sf $bindir/$1.so $2.so
192 }
193
194 #puts windows applications replacements to windows directories,
195 #configures them
196 function configure_wine_applications {
197   link_app regedit      "$CROOT/windows/regedit.exe"
198   link_app uninstaller  "$CROOT/windows/uninstall.exe"
199   link_app wcmd         "$CROOT/windows/system32/cmd.exe"
200   link_app control      "$CROOT/windows/system32/control.exe"
201   link_app winhelp      "$CROOT/windows/system32/help.exe"
202   link_app notepad      "$CROOT/windows/system32/notepad.exe"
203   link_app progman      "$CROOT/windows/system32/progman.exe"
204   link_app regsvr32     "$CROOT/windows/system32/regsvr32.exe"
205   link_app winemine     "$CROOT/windows/system32/winmine.exe"
206   link_app winver       "$CROOT/windows/system32/winver.exe"
207 }
208
209 # startup...
210
211 echo "WINE Installer v0.73"
212 echo
213
214 if [ "$BINDIST" = 'no' ]
215 then {
216
217   if ! [ -f configure ]
218   then {
219     echo "You're running this from the wrong directory."
220     echo "Change to the Wine source's main directory and try again."
221     exit 1
222   }
223   fi
224
225   if [ `whoami` == 'root' ]
226   then {
227     echo "You are running wineinstall as root, this is not advisable. Please rerun as a user."
228     echo "Aborting."
229     exit 1
230   }
231   fi
232
233   # check whether RPM installed, and if it is, remove any old wine rpm.
234   hash rpm &>/dev/null
235   RET=$?
236   if [ $RET -eq 0 ]; then
237     if [ -n "`rpm -qi wine 2>/dev/null|grep "^Name"`" ]; then
238       echo "Warning: Old Wine RPM install detected. Do you want to remove it first?"
239       conf_yesno_answer "(yes/no) "
240       if [ "$ANSWER" = 'yes' ]; then
241         echo "We need to remove the rpm as root, please enter your root password"
242         echo
243         echo Starting wine rpm removal...
244         su -c "rpm -e wine; RET=$?"
245         if [ $RET -eq 0 ]; then
246           echo Done.
247         else
248           echo "FAILED. Probably you aren't installing as root."
249           echo "Expect problems (library conflicts with existing install etc.)."
250         fi
251       else
252         echo "Sorry, I won't install Wine when an rpm version is still installed."
253         echo "(Wine support suffered from way too many conflicts between RPM"
254         echo "and source installs)"
255         echo "Have a nice day !"
256         exit 1
257       fi
258     fi
259   fi
260
261   # check whether wine binary still available
262   if [ -n "`which wine 2>/dev/null|grep '/wine'`" ]; then
263     echo "Warning !! wine binary (still) found, which may indicate"
264     echo "a (conflicting) previous installation."
265     echo "You might want to abort and uninstall Wine first."
266     std_sleep
267   fi
268
269   # run the configure script, if necessary
270
271   if [ -f config.cache ] && [ -f Makefile ] && [ Makefile -nt configure ]
272   then {
273     echo
274     echo "I see that WINE has already been configured, so I'll skip that."
275     std_sleep
276     # load configure results
277     . ./config.cache
278   }
279   else {
280     echo "Running configure..."
281     echo
282     if ! ./configure -C $CONFARGS
283     then {
284       echo
285       echo "Configure failed, aborting install."
286       rm -f config.cache
287       exit 1
288     }
289     fi
290     # load configure results
291     . ./config.cache
292     # make sure X was found
293     eval "$ac_cv_have_x"
294     if [ "$have_x" != "yes" ]
295     then {
296       echo "Install the X development headers and try again."
297       rm -f config.cache
298       exit 1
299     }
300     fi
301   }
302   fi
303
304   # now do the compilation and install, we need to always do this because we
305   # don't want the 'make install' command we might run to run 'make' as root
306   if [ `whoami` != 'root' ]
307   then {
308     # ask the user if they want to build and install wine
309     echo
310     echo "We need to install wine as root user, do you want us to build wine,"
311     echo "'su root' and install Wine?  Enter 'no' to continue without installing"
312     conf_yesno_answer "(yes/no) "
313
314     if [ "$ANSWER" = "yes" ]
315     then {
316       # start out with the basic command
317       sucommand="make install"
318
319       # if the user doesn't have $libdir in their ld.so.conf add this
320       # to our sucommand string
321       if [ -f /etc/ld.so.conf ]
322       then
323         if ! grep -qs "$libdir" /etc/ld.so.conf
324         then {
325           echo
326           echo "$libdir doesn't exist in your /etc/ld.so.conf, it will be added"
327           echo "when we perform the install..."
328           sucommand="$sucommand;echo $libdir>>/etc/ld.so.conf"
329         }
330         fi
331         # run ldconfig always just in case some updated files dont get linked
332         sucommand="$sucommand;$ac_cv_path_LDCONFIG"
333       fi
334
335       echo
336
337       echo "Compiling WINE. Grab a lunch or two, rent a video, or whatever,"
338       echo "in the meantime..."
339       echo
340       std_sleep
341
342       # try to just make wine, if this fails 'make depend' and try to remake
343       if ! { make; }
344       then {
345         if ! { make depend && make; }
346         then {
347           echo
348           echo "Compilation failed, aborting install."
349           exit 1
350         }
351         fi
352       }
353       fi
354       echo
355
356       echo "Performing 'make install' as root to install binaries, enter root password"
357
358       std_sleep
359
360       if ! su root -c "$sucommand"
361       then {
362         echo
363         echo "Either you entered an incorrect password or we failed to run"
364         echo "'$sucommand' correctly."
365         echo "If you didn't enter an incorrect password then please report this"
366         echo "error and any steps to possibly reproduce it to"
367         echo "http://bugs.winehq.com/"
368         echo
369         echo "Installation failed, aborting."
370         exit 1
371       }
372       fi
373
374       echo
375
376       # see if wine is installed on the users system, if not prompt them
377       # and then exit
378       if [ ! `which wine` ]
379       then
380         echo "Could not find wine on your system.  Run wineinstall as root to install wine"
381         echo "before re-running wineinstall as a user."
382         echo
383         echo "Exiting wineinstall"
384         exit 1;
385       fi
386     }
387     else {
388       # user didn't want to install wine so tell them about running from the
389       # current directory and set some stuff up for them
390
391       # setup to run from current directory
392       DLLPATH="$PWD/dlls"
393       if [ -z "$LD_LIBRARY_PATH" ]
394       then LD_LIBRARY_PATH="$PWD:$DLLPATH"
395       else LD_LIBRARY_PATH="$LD_LIBRARY_PATH:$PWD:$DLLPATH"
396       fi
397       export LD_LIBRARY_PATH
398       DEBUGGER="$PWD/$HDEBUGGER"
399       echo
400       echo "NOTE! To run Wine without installing, you must set the environment variable"
401       echo "LD_LIBRARY_PATH to $PWD:$DLLPATH"
402       echo "in your logon scripts."
403       echo
404     }
405     fi
406   }
407   fi # [ `whoami` != 'root' ]
408
409 }
410 fi # BINDIST
411
412 # now check whether we should generate wine.conf
413 if [ -z "$DOGLOBALCONF" ]
414 then
415   DOGLOBALCONF=auto
416 fi
417
418 if [ "$DOGLOBALCONF" = 'auto' ]
419 then {
420   # see if we already have a system wine.conf
421   if [ ! -f $GCONF ] && [ `whoami` = 'root' ]
422   then
423     DOGLOBALCONF=no
424     echo "Creation of a global config file is not supported in wineinstall at this"
425     echo "time.  When the configuration architecture is cleaned up this functionality"
426     echo "will be restored to wineinstall."
427     echo
428   fi
429 }
430 fi
431
432 if [ "$DOLOCALCONF" = 'auto' ]
433 then {
434   # see if the user is root, if so, explicitly ask them if they want a
435   # local config file
436   if [ `whoami` = 'root' ]
437   then
438     echo "You are running as root.  Do you want a local config file,"
439     echo "file, ~/.wine/config, created?"
440     conf_yesno_answer "(yes/no) "
441     DOLOCALCONF="$ANSWER"
442   else
443     # if the user has an existing config file ask them if they want us to
444     # overwrite it, otherwise just ask them if they want to create one
445     if [ -f "$LCONF" ]
446     then
447       echo "Found existing $LCONF, do you want to overwrite this"
448       echo "existing Wine configuration file?"
449       conf_yesno_answer "(yes/no) "
450       DOLOCALCONF="$ANSWER"
451       echo
452       if [ "$ANSWER" = "yes" ]
453       then
454       {
455         echo "Would you like to make a backup of this old config file?"
456         conf_yesno_answer "(yes/no) "
457         echo
458         if [ "$ANSWER" = "yes" ]
459         then
460         {
461           echo "Renaming $LCONF to $LCONF.old"
462           mv -f "$LCONF" "$LCONF.old"
463           echo
464         }
465         fi
466       }
467       fi
468     else
469     {
470       echo "Create local config file ~/.wine/config?"
471       conf_yesno_answer "(yes/no) "
472       DOLOCALCONF="$ANSWER"
473       echo
474       if [ "$ANSWER" = 'no' ]
475       then
476         conf_question high need_root \
477           "Aborting install. Try again as root to generate a system wine.conf."
478         exit 1
479       fi
480     }
481     fi
482   fi
483 }
484 fi
485
486 # generate $TMPCONF from existing windows install, if any
487 if [ "$DOLOCALCONF" = 'yes' ]
488 then {
489   if [ "$DOWCHK" = 'yes' ] || [ "$DOWCHK" = 'auto' ]
490   then {
491     echo -n "Searching for an existing Windows installation..."
492     if ! $WINECONF -inifile "$WINEINI" > $TMPCONF 2>/dev/null
493     then {
494       rm -f $TMPCONF $TMPREG > /dev/null
495
496       echo " not found. (no matching /etc/fstab mount entry found)"
497       conf_question low do_without_windows \
498        "Windows was not found on your system, so I assume you want" \
499        "a Wine-only installation. Am I correct?"
500       conf_yesno_answer "(yes/no) "
501       if [ "$ANSWER" = 'no' ]
502       then {
503         conf_question high windows_not_found \
504          "Aborting install. Make sure your Windows partition is mounted and try again," \
505          "or create $LCONF manually by copying from $WINEINI and adapting the drive paths."
506         exit 1
507       }
508       fi
509       DOWINE=yes
510     }
511     else {
512       echo " found."
513
514       conf_reset_question windows_found
515       conf_question low windows_found \
516        "Created $LCONF using your existing Windows installation." \
517        "You probably want to review the file, though."
518       DOWINE=no
519     }
520     fi
521   }
522   elif [ "$DOWINE" = 'auto' ]
523   then DOWINE=yes
524   fi
525 }
526 elif [ "$DOWINE" = 'auto' ]
527 then
528   DOWINE=no
529 fi
530
531 # setup a no-windows installation, if necessary
532 if [ "$DOWINE" = 'yes' ]
533 then {
534   # set an appropriate DCROOT
535   if [ `whoami` != 'root' ]
536   then DCROOT=~/c
537   else DCROOT=/c
538   fi
539
540   if [ -f ~/.winerc ]
541   then {
542     conf_question medium convert_config \
543      "I found the old version Wine config file, .winerc, in your " \
544      "home directory.  I can convert this to the new format or use the" \
545      "new default Wine config file. Convert?"
546     conf_yesno_answer "(yes/no) "
547     if [ "$ANSWER" = 'yes' ]
548     then {
549       WINEINI=~/.winerc
550       CONVCONF=yes
551     }
552     fi
553   }
554   else {
555
556     conf_question low drivec_path \
557      "Configuring Wine without Windows." \
558      "Some fake Windows directories must be created, to hold any .ini files, DLLs," \
559      "start menu entries, and other things your applications may need to install." \
560      "Where would you like your fake C drive to be placed?"
561     while [ -z "$CROOT" ]
562     do {
563       conf_string_answer "(default is $DCROOT) "
564       [ -z "$ANSWER" ] && ANSWER="$DCROOT"
565       if ! [ -d "$ANSWER" ]
566       then {
567         if mkdir -p "$ANSWER"
568         then CROOT="$ANSWER"
569         else
570           echo "Directory $ANSWER can't be created !"
571           conf_reset_question drivec_path
572         fi
573       }
574       else CROOT="$ANSWER"
575       fi
576     }
577     done
578     echo "Configuring Wine for a no-windows install in $CROOT..."
579
580     create_windows_directories
581     configure_wine_applications
582   }
583   fi
584
585   # create $LCONF using the default config file $WINEINI
586   if [ "$DOLOCALCONF" = 'yes' ] && [ "$CONVCONF" = 'no' ]
587   then {
588     sed "s|\"Path\" = \"/c\"\$|\"Path\" = \"${CROOT}\"|" $WINEINI > $TMPCONF
589     conf_reset_question default_config
590     conf_question low default_config \
591      "Created $LCONF using default Wine configuration." \
592      "You probably want to review the file, though."
593   }
594   fi
595
596   # now we really should install the registry
597   if [ "$DOREG" = 'auto' ]
598   then DOREG=yes
599   fi
600 }
601 fi
602 echo
603
604 #install the local config file $LCONF
605 if [ "$DOLOCALCONF" = 'yes' ]
606 then
607   if [ ! -w ~/.wine ]
608   then
609     mkdir ~/.wine
610   fi
611
612   if [ "$CONVCONF" = 'no' ]
613   then
614     cp $TMPCONF $LCONF > /dev/null
615   fi
616 else
617   DOREG=no
618 fi
619
620 #install the global config file $GCONF
621 if [ "$DOGLOBALCONF" = 'yes' ]
622 then
623   if [ ! -f $sysconfdir ]
624   then
625     mkdir -p $sysconfdir
626   fi
627
628   cp $TMPCONF $GCONF > /dev/null
629 fi
630
631 # check whether we need to install default registry
632 # (not to be done if windows registry exists)
633 if [ "$DOREG" = 'auto' ]
634 then {
635   CROOT=`sed -n '/^\[Drive C\]$/,/^\[.*\]$/ s/^\"Path\" = \"\(.*\)\"/\1/p' $LCONF`
636   echo "Checking for real Windows registry..."
637   if [ -f "$CROOT/windows/system.dat" ]
638   then DOREG=no
639   elif [ -f "$CROOT/windows/system32/config/system" ]
640   then DOREG=no
641   elif [ -f "$CROOT/WINNT/system32/config/system" ]
642   then DOREG=no
643   else DOREG=yes
644   fi
645   if [ "$DOREG" = 'yes' ]
646   then echo "Not found, default Wine registry will be installed."
647   else echo "Windows registry found, will not install default Wine registry."
648   fi
649   echo
650 }
651 fi
652
653 # install default registry entries
654 if [ "$DOREG" = 'yes' ]
655 then {
656   if [ "$BINDIST" = 'no' ]
657   then {
658     echo "Compiling regedit..."
659     (cd programs/regedit; make)
660     echo
661   }
662   fi
663   echo "Preparing to install default Wine registry entries..."
664
665   # edit config files so we don't have to run regedit under X
666   if [ "$CONVCONF" = 'yes' ]
667   then
668     mv $WINEINI $WINEINI.new
669     sed "s/GraphicsDriver=.*/GraphicsDriver=ttydrv/" $WINEINI.new > $WINEINI
670   else
671     mv $LCONF $LCONF.new
672     sed "s/\"GraphicsDriver\" = .*/\"GraphicsDriver\" = \"ttydrv\"/" $LCONF.new > $LCONF
673   fi
674
675   # create a temporary wineinstall.reg with fixed debugger path
676   $DEFCAT $DEFREG | sed "s|debugger/winedbg|${DEBUGGER}|" > $TMPREG
677
678   echo "Installing default Wine registry entries..."
679   echo
680   if ! $REGEDIT $TMPREG > /dev/null
681   then {
682     rm -f $TMPREG
683     echo "Registry install failed."
684     conf_reset_question regedit_error
685     conf_question high regedit_error
686     exit 1
687   }
688   else {
689     # if we are converting from a .winerc file, running regedit once
690     # will ONLY convert .winerc -> ~/.wine/config, it will not import the
691     # registry data.  so if we are converting we need to run regedit twice
692     if [ "$CONVCONF" = 'yes' ]
693     then
694       if ! $REGEDIT $TMPREG > /dev/null
695       then
696         rm -f $TMPREG
697         echo "Registry install failed."
698         conf_reset_question regedit_error
699         conf_question high regedit_error
700         exit 1
701       else
702         echo
703         echo "Registry entries successfully installed."
704       fi
705     else
706       echo
707       echo "Registry entries successfully installed."
708     fi
709   }
710   fi
711   rm -f $TMPREG
712   if [ "$SYSREG" = 'auto' ]
713   then SYSREG=yes
714   fi
715
716   # if we converted we need to change the graphics driver back and
717   # restore the original .winerc file
718   if [ "$CONVCONF" = 'yes' ]
719   then
720      mv $WINEINI.new $WINEINI
721   fi
722
723   sed "s/\"GraphicsDriver\" = .*/\"GraphicsDriver\" = \"x11drv\"/" $LCONF > $LCONF.new
724   mv $LCONF.new $LCONF
725 }
726 fi
727
728 # make root's registry global, if desired
729 if [ `whoami` = 'root' ] && [ "$DOREG" = 'yes' ] && [ "$SYSREG" = 'yes' ]
730 then {
731   [ -d ~/.wine ] || mkdir ~/.wine
732   if ! [ -f $sysconfdir/wine.userreg ]
733   then {
734     echo "Linking root's user registry hive to the global registry..."
735     [ -f ~/.wine/wine.userreg ] && cp ~/.wine/wine.userreg $sysconfdir/wine.userreg
736     ln -sf $sysconfdir/wine.userreg ~/.wine/wine.userreg
737   }
738   fi
739   if ! [ -f $sysconfdir/wine.systemreg ]
740   then {
741     echo "Linking root's system registry hive to the global registry..."
742     [ -f ~/.wine/system.reg ] && cp ~/.wine/system.reg $sysconfdir/wine.systemreg
743     ln -sf $sysconfdir/wine.systemreg ~/.wine/system.reg
744   }
745   fi
746 }
747 fi
748
749 # cleanup any temporary files that may remain
750 if [ -f $TMPCONF ]
751 then rm -f $TMPCONF
752 fi
753 if [ -f $TMPREG ]
754 then rm -f $TMPREG
755 fi
756
757
758 # it's a wrap
759 echo
760 echo "Installation complete for now. Good luck (this is still alpha software)."
761 echo "If you have problems with WINE, please read the documentation first,"
762 echo "as many kinds of potential problems are explained there."
763
764 exit 0